<template>
  <div>
    <v-dialog v-model="dialog" persistent max-width="1000" attach="#app">
      <v-card>
        <v-card-title
          class="pl-4 pr-1 py-1 text-subtitle-1 primary white--text"
        >
          {{ $t("tool.page.settings.title") }}
          <v-spacer />
          <GIconBtn
            i18n="form.close"
            icon="mdi-close"
            small
            small-btn
            btn-class="theme--dark"
            @click="dialog = false"
          />
        </v-card-title>
        <v-divider class="mx-4" />
        <div class="v-card-group">
          <!-- region language settings -->
          <v-card>
            <v-card-title class="pb-0">
              <h3 class="text-h5">
                {{ $t("tool.page.settings.language.title") }}
              </h3>
            </v-card-title>
            <v-card-text>
              <v-form>
                <v-select
                  v-model="locale"
                  prepend-icon="language"
                  :items="$i18n.locales"
                  item-text="name"
                  item-value="code"
                  :label="$t('tool.page.settings.language.selectLanguage')"
                />
              </v-form>
            </v-card-text>
          </v-card>
          <!-- endregion -->
          <v-card>
            <v-card-title class="pb-0">
              <h3 class="text-h5">
                {{ $t("tool.page.settings.theme.title") }}
              </h3>
            </v-card-title>
            <v-card-text>
              <v-form>
                <GCheckbox
                  v-model="listMode"
                  i18n="tool.page.settings.theme.listMode"
                />
                <v-alert color="warning" icon="warning" outlined class="mb-3">
                  {{ $t("tool.page.settings.theme.warning") }}
                </v-alert>
                <v-select
                  v-model="currentTheme"
                  prepend-icon="language"
                  :items="availableThemes"
                  item-text="name"
                  item-value="key"
                  :label="$t('tool.page.settings.theme.selectTheme')"
                />
              </v-form>
            </v-card-text>
          </v-card>
          <v-card>
            <v-card-actions>
              <v-spacer />
              <v-btn color="success" @click="save">
                {{ $t("form.save") }}
              </v-btn>
            </v-card-actions>
          </v-card>
        </div>
      </v-card>
    </v-dialog>
    <GIconBtn
      i18n="tool.page.settings.title"
      icon="mdi-cog"
      @click="dialog = true"
    />
  </div>
</template>

<script>
import { availableThemes, themeMixin } from "~/components/Mixins/theme";
import GCheckbox from "~/components/App/Form/gCheckbox";
import GIconBtn from "~/components/App/Common/GIconBtn.vue";

export default {
  name: "Settings",
  components: { GIconBtn, GCheckbox },
  mixins: [themeMixin],
  data() {
    return {
      locale: this.$i18n.locale,
      currentTheme: null,
      listMode: null,
      availableThemes: Object.entries(availableThemes).map(([key, value]) => {
        value.key = key.substr(0, key.indexOf("Theme"));
        value.name = this.$t(`tool.page.settings.theme.${key}`);
        return value;
      }),
      dialog: false,
    };
  },
  mounted() {
    this.currentTheme = this.themeName;
    this.listMode = this.$warehouse.get("listMode", true);
  },
  methods: {
    async save() {
      this.setTheme(this.currentTheme);
      this.$warehouse.set("listMode", this.listMode);

      this.$warehouse.set("locale", this.locale);
      if (this.$i18n.locale !== this.locale) {
        this.$nuxt.$router.replace({
          path: this.gSwitchLocalePath(this.locale),
        });
      }
      this.updateListMode();
      await this.$nextTick();

      this.dialog = false;
    },
  },
};
</script>
